/*
	This file is part of cpso.

	cpso is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	cpso is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with cpso.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2010 Lucas Hermann Negri
*/

#include <cpso.h>
#include <stdio.h>
#include <assert.h>

double eval(CpsoState* st, const double* p)
{
    return p[0] + p[1] + p[2];
}

int main(int argc, char* argv[])
{
    CpsoState* st = cpso_new(3, 10);
    st->ud = st;
    
    cpso_set_limits(st, 0, -10, 10);
    cpso_set_limits(st, 1, -10, 10);
    cpso_set_limits(st, 2, -10, 10);
    cpso_set_eval  (st, &eval, NULL);
    cpso_init(st);
    
    cpso_step(st);
    
    int p;
    for(p = 0; p < st->n_pop; ++p)
        assert(st->b_fit[p] == (st->b_pos[p][0] + st->b_pos[p][1] + st->b_pos[p][2]) );
    
    cpso_free(st);
    
    return 0;
}
