/*
	This file is part of cpso.

	cpso is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	cpso is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with cpso.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2010 Lucas Hermann Negri
*/

#include <cpso.h>
#include <stdio.h>
#include <assert.h>
#include <math.h>
#include <time.h>

#define N_ITER 50000 
#define N_PART 100
#define N_DIM  5

int i = 0;

double eval(CpsoState* st, const double* p)
{
    ++i;
    return p[0] + p[1] + p[2] + p[3] + p[4];
}

int main(int argc, char* argv[])
{
    CpsoState* st = cpso_new(N_DIM, N_PART);
    
    cpso_set_limits(st, 0, -100, 100);
    cpso_set_limits(st, 1, -100, 100);
    cpso_set_limits(st, 2, -100, 100);
    cpso_set_limits(st, 3, -100, 100);
    cpso_set_limits(st, 4, -100, 100);
    cpso_set_eval  (st, &eval, NULL);
    srand( time(0) );
    cpso_init(st);
    
    cpso_run(st, N_ITER, 9999);
    assert(i == N_ITER * N_PART + N_PART + 1);
    cpso_free(st);
    
    return 0;
}
