/*
	This file is part of cpso.

	cpso is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	cpso is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with cpso.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2010 Lucas Hermann Negri
*/

#include <cpso.h>
#include <stdio.h>
#include <assert.h>

int main(int argc, char* argv[])
{
    int i = 0;
    for(i = 0; i < 10000; ++i)
    {
        CpsoState* st = cpso_new(5, 30);
        
        int p;
        for(p = 0; p < 30; ++p)
        {            
            int d;
            for(d = 0; d < 5; ++d)
            {
                st->limits[d * 2]     = -d;
                st->limits[d * 2 + 1] =  d;
                st->velo [p][d]       = p + d + 1;
                st->space[p][d]       = p + d + 2;
            }
            
            st->b_fit[p]        = p + 2;
        }
        
        for(p = 0; p < 30; ++p)
        {
            int d;
            for(d = 0; d < 5; ++d)
            {
                assert(st->limits[d * 2]     == -d);
                assert(st->limits[d * 2 + 1] ==  d);
                assert(st->velo[p][d]        == p + d + 1);
                assert(st->space[p][d]       == p + d + 2);
            }
            
            assert(st->b_fit[p]      == p + 2);
        }
        
        cpso_free(st);
    }
    
    return 0;
}
